<?php

class GalleryController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
        $images = array();
        $obj_list = new Application_Model_View_ListLogic(-1);
        $keys = array();
        foreach($obj_list->fetchAll() as $list) {
            array_push($keys, $list->city_name);
            array_push($keys, $list->list_title);
            $image = array(
                'title'=>$list->list_title.' '.$list->list_address.' '.$list->city_name, 
                'image'=> Application_Model_Cache_Config::getConfig("SITE_URL").'img/'.Application_Model_Cache_Config::getConfig('LIST_FOLDER').'/'.$list->list_image,
                'url'=> $list->list_url
            );
            array_push($images, $image);
            $obj_img = new Application_Model_ListImageLogic(-1);
            foreach($obj_img->getActiveImage($list->id) as $img) {
                $image = array(
                    'title'=>$list->list_title.' '.$list->list_address.' '.$list->city_name, 
                    'image'=> Application_Model_Cache_Config::getConfig("SITE_URL").'img/'.Application_Model_Cache_Config::getConfig('LIST_FOLDER').'/'.$img->image_path,
                    'url'=> $list->list_url
                );
                array_push($images, $image);
            }
        }
        $keys = array_unique($keys);
        $this->view->images = $images;
     
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'pictures, images, delicious, food, hunger, food, daddy, '. implode(', ', $keys)); 
        $layout->assign('meta_desc', 'Explore the images from Hunger Daddy corner. We are sharing the dish pictures with all of you.');
        $layout->assign('page_title', 'Gallery');
    }
    
}