<?php

class ProductController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
        $url = urldecode($this->_getParam('cat'));
        
        $obj_cat = new Application_Model_CategoryLogic(-1);
        $catId = $obj_cat->getIdByTitle($url);
        $this->view->category = $obj_cat = new Application_Model_CategoryLogic($catId);
        $this->view->catUrl = $obj_cat->convertToUrl($obj_cat->get_category_title());
        
        $obj_product = new Application_Model_ProductLogic(-1);
        $this->view->products = $obj_product->fetchOrdered($obj_cat->get_id());
        
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', $obj_cat->get_category_meta_key()); 
        $layout->assign('meta_desc', $obj_cat->get_category_meta_desc());
        $layout->assign('page_title', $obj_cat->get_category_title().' Products');
    }
    
    public function viewAction()
    {
        $url = urldecode($this->_getParam('url'));
        
        $obj_product = new Application_Model_ProductLogic(-1);
        $this->view->product = $obj_product->getProductByUrl($url);
        
        $obj_cat = new Application_Model_CategoryLogic($obj_product->get_product_category());
        $this->view->category = $obj_cat;
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', $obj_product->get_product_meta_key()); 
        $layout->assign('meta_desc', $obj_product->get_product_meta_desc());
        $layout->assign('page_title', $obj_product->get_product_name().' Information');
    }
    
    
}