<?php
class Application_Form_Appointment extends Zend_Form
{
    
    public function init()
    {
        
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $appointment_id = new Zend_Form_Element_Hidden("id");
        
        $appointment_confirm = new Zend_Form_Element_Checkbox("appointment_confirm");
        $appointment_confirm->setLabel("Is Confirm?")->setValue("Confirmed");
        
        $appointment_remarks = new Zend_Form_Element_Text("appointment_remarks");
        $appointment_remarks->setLabel("Remarks")->setRequired(true);
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib("class", "btn btn-blue4");
        
        $this->addElements(array($token,
            $appointment_id,
            $appointment_confirm,
            $appointment_remarks,
            $save));
    }
    
    
}