<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Master
 *
 * @author Akhil Kumar
 */
class Application_Model_Api_Issue {
    
    public function store($body) {
        
        $obj_api_util = new Application_Model_Api_Util();
        $data = $obj_api_util->decode($body);
        
        $issues = array();
        if(is_array($data) && count($data) > 0) {
            $obj_issue = new Application_Model_IssueLogic(-1);
            $issues = $obj_issue->insertIssues($data);
        }
        
        return $obj_api_util->encode($issues); 
    }
    
    public function get() {
        
        $obj_api_util = new Application_Model_Api_Util();
        
        $issues = array();
        $obj_issue = new Application_Model_IssueFileLogic(-1);
        foreach ($obj_issue->fetchUnsyncOrderd() as $issue) {
            array_push($issues, $issue->toArray());
        }
        
        return $obj_api_util->encode($issues);
    }
    
    public function confirm($body) {
        
        $obj_api_util = new Application_Model_Api_Util();
        $data = $obj_api_util->decode($body);
        
        if(is_array($data) && count($data) > 0) {
            foreach ($data as $id) {
                $obj_issue = new Application_Model_IssueFileLogic($id);
                $obj_issue->set_issue_sync(1);
                $obj_issue->save();
            }
        }
        
        return $obj_api_util->encode($data); 
        
    }
    
}
