<?php

class Application_Model_Claim extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_claim';

    private $_id = null;

    private $_claim_num = null;
    
    private $_claim_ref_num = null;

    private $_claim_fy = null;

    private $_claim_type = null;
    
    private $_claim_loss_time = null;

    private $_claim_loss_type = null;

    private $_claim_loss_nature = null;

    private $_department = null;

    private $_policy = null;

    private $_policy_number = null;

    private $_insurance_company = null;

    private $_claim_insured = null;

    private $_insured = null;

    private $_estimated_loss = null;

    private $_material_loss = null;

    private $_ho_id = null;

    private $_ho_address = null;

    private $_division_id = null;

    private $_division_address = null;

    private $_region_id = null;

    private $_region_address = null;

    private $_bo_id = null;

    private $_bo_address = null;

    private $_survey_provisional = null;

    private $_claim_remarks = null;

    private $_status = null;

    private $_survey_date = null;

    private $_age_month = null;
    
    private $_claim_amount_claimed = null;
    
    private $_claim_amount_gross = null;
    
    private $_claim_amount_pay = null;
    
    private $_claim_reports = null;
    
    private $_claim_user = null;

    private $_claim_updated_date = null;

    private $_claim_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get claim_num method is stand for get the value of claim_num.
     *
     * @var varchar claim_num
     */
    public function get_claim_num()
    {
        return $this->_claim_num;
    }

    /**
     * set claim_num method is stand for set the value of claim_num.
     *
     * @var varchar claim_num
     */
    public function set_claim_num($value)
    {
        $this->_claim_num = $value;
    }
    
    /**
     * get claim_ref_num method is stand for get the value of claim_num.
     *
     * @var varchar claim_ref_num
     */
    public function get_claim_ref_num()
    {
        return $this->_claim_ref_num;
    }

    /**
     * set claim_ref_num method is stand for set the value of claim_num.
     *
     * @var varchar claim_ref_num
     */
    public function set_claim_ref_num($value)
    {
        $this->_claim_ref_num = $value;
    }

    /**
     * get claim_fy method is stand for get the value of claim_fy.
     *
     * @var varchar claim_fy
     */
    public function get_claim_fy()
    {
        return $this->_claim_fy;
    }

    /**
     * set claim_fy method is stand for set the value of claim_fy.
     *
     * @var varchar claim_fy
     */
    public function set_claim_fy($value)
    {
        $this->_claim_fy = $value;
    }

    /**
     * get claim_type method is stand for get the value of claim_type.
     *
     * @var varchar claim_type
     */
    public function get_claim_type()
    {
        return $this->_claim_type;
    }

    /**
     * set claim_type method is stand for set the value of claim_type.
     *
     * @var varchar claim_type
     */
    public function set_claim_type($value)
    {
        $this->_claim_type = $value;
    }

    /**
     * get claim_loss_type method is stand for get the value of claim_loss_time.
     *
     * @var varchar claim_loss_time
     */
    public function get_claim_loss_time()
    {
        return $this->_claim_loss_time;
    }

    /**
     * set claim_loss_type method is stand for set the value of claim_loss_time.
     *
     * @var varchar claim_loss_time
     */
    public function set_claim_loss_time($value)
    {
        $this->_claim_loss_time = $value;
    }
    
    /**
     * get claim_loss_type method is stand for get the value of claim_loss_type.
     *
     * @var varchar claim_loss_type
     */
    public function get_claim_loss_type()
    {
        return $this->_claim_loss_type;
    }

    /**
     * set claim_loss_type method is stand for set the value of claim_loss_type.
     *
     * @var varchar claim_loss_type
     */
    public function set_claim_loss_type($value)
    {
        $this->_claim_loss_type = $value;
    }

    /**
     * get claim_loss_nature method is stand for get the value of claim_loss_nature.
     *
     * @var varchar claim_loss_nature
     */
    public function get_claim_loss_nature()
    {
        return $this->_claim_loss_nature;
    }

    /**
     * set claim_loss_nature method is stand for set the value of claim_loss_nature.
     *
     * @var varchar claim_loss_nature
     */
    public function set_claim_loss_nature($value)
    {
        $this->_claim_loss_nature = $value;
    }

    /**
     * get department method is stand for get the value of department.
     *
     * @var varchar department
     */
    public function get_department()
    {
        return $this->_department;
    }

    /**
     * set department method is stand for set the value of department.
     *
     * @var varchar department
     */
    public function set_department($value)
    {
        $this->_department = $value;
    }

    /**
     * get policy method is stand for get the value of policy.
     *
     * @var varchar policy
     */
    public function get_policy()
    {
        return $this->_policy;
    }

    /**
     * set policy method is stand for set the value of policy.
     *
     * @var varchar policy
     */
    public function set_policy($value)
    {
        $this->_policy = $value;
    }

    /**
     * get policy_number method is stand for get the value of policy_number.
     *
     * @var varchar policy_number
     */
    public function get_policy_number()
    {
        return $this->_policy_number;
    }

    /**
     * set policy_number method is stand for set the value of policy_number.
     *
     * @var varchar policy_number
     */
    public function set_policy_number($value)
    {
        $this->_policy_number = $value;
    }

    /**
     * get insurance_company method is stand for get the value of insurance_company.
     *
     * @var varchar insurance_company
     */
    public function get_insurance_company()
    {
        return $this->_insurance_company;
    }

    /**
     * set insurance_company method is stand for set the value of insurance_company.
     *
     * @var varchar insurance_company
     */
    public function set_insurance_company($value)
    {
        $this->_insurance_company = $value;
    }

    /**
     * get claim_insured method is stand for get the value of claim_insured.
     *
     * @var int claim_insured
     */
    public function get_claim_insured()
    {
        return (int) $this->_claim_insured;
    }

    /**
     * set claim_insured method is stand for set the value of claim_insured.
     *
     * @var int claim_insured
     */
    public function set_claim_insured($value)
    {
        $this->_claim_insured = (int) $value;
    }

    /**
     * get insured method is stand for get the value of insured.
     *
     * @var varchar insured
     */
    public function get_insured()
    {
        return $this->_insured;
    }

    /**
     * set insured method is stand for set the value of insured.
     *
     * @var varchar insured
     */
    public function set_insured($value)
    {
        $this->_insured = $value;
    }

    /**
     * get estimated_loss method is stand for get the value of estimated_loss.
     *
     * @var varchar estimated_loss
     */
    public function get_estimated_loss()
    {
        return $this->_estimated_loss;
    }

    /**
     * set estimated_loss method is stand for set the value of estimated_loss.
     *
     * @var varchar estimated_loss
     */
    public function set_estimated_loss($value)
    {
        $this->_estimated_loss = $value;
    }

    /**
     * get material_loss method is stand for get the value of material_loss.
     *
     * @var varchar material_loss
     */
    public function get_material_loss()
    {
        return $this->_material_loss;
    }

    /**
     * set material_loss method is stand for set the value of material_loss.
     *
     * @var varchar material_loss
     */
    public function set_material_loss($value)
    {
        $this->_material_loss = $value;
    }

    /**
     * get ho_id method is stand for get the value of ho_id.
     *
     * @var int ho_id
     */
    public function get_ho_id()
    {
        return (int) $this->_ho_id;
    }

    /**
     * set ho_id method is stand for set the value of ho_id.
     *
     * @var int ho_id
     */
    public function set_ho_id($value)
    {
        $this->_ho_id = (int) $value;
    }

    /**
     * get ho_address method is stand for get the value of ho_address.
     *
     * @var varchar ho_address
     */
    public function get_ho_address()
    {
        return $this->_ho_address;
    }

    /**
     * set ho_address method is stand for set the value of ho_address.
     *
     * @var varchar ho_address
     */
    public function set_ho_address($value)
    {
        $this->_ho_address = $value;
    }

    /**
     * get division_id method is stand for get the value of division_id.
     *
     * @var int division_id
     */
    public function get_division_id()
    {
        return (int) $this->_division_id;
    }

    /**
     * set division_id method is stand for set the value of division_id.
     *
     * @var int division_id
     */
    public function set_division_id($value)
    {
        $this->_division_id = (int) $value;
    }

    /**
     * get division_address method is stand for get the value of division_address.
     *
     * @var varchar division_address
     */
    public function get_division_address()
    {
        return $this->_division_address;
    }

    /**
     * set division_address method is stand for set the value of division_address.
     *
     * @var varchar division_address
     */
    public function set_division_address($value)
    {
        $this->_division_address = $value;
    }

    /**
     * get region_id method is stand for get the value of region_id.
     *
     * @var int region_id
     */
    public function get_region_id()
    {
        return (int) $this->_region_id;
    }

    /**
     * set region_id method is stand for set the value of region_id.
     *
     * @var int region_id
     */
    public function set_region_id($value)
    {
        $this->_region_id = (int) $value;
    }

    /**
     * get region_address method is stand for get the value of region_address.
     *
     * @var varchar region_address
     */
    public function get_region_address()
    {
        return $this->_region_address;
    }

    /**
     * set region_address method is stand for set the value of region_address.
     *
     * @var varchar region_address
     */
    public function set_region_address($value)
    {
        $this->_region_address = $value;
    }

    /**
     * get bo_id method is stand for get the value of bo_id.
     *
     * @var int bo_id
     */
    public function get_bo_id()
    {
        return (int) $this->_bo_id;
    }

    /**
     * set bo_id method is stand for set the value of bo_id.
     *
     * @var int bo_id
     */
    public function set_bo_id($value)
    {
        $this->_bo_id = (int) $value;
    }

    /**
     * get bo_address method is stand for get the value of bo_address.
     *
     * @var varchar bo_address
     */
    public function get_bo_address()
    {
        return $this->_bo_address;
    }

    /**
     * set bo_address method is stand for set the value of bo_address.
     *
     * @var varchar bo_address
     */
    public function set_bo_address($value)
    {
        $this->_bo_address = $value;
    }

    /**
     * get survey_provisional method is stand for get the value of survey_provisional.
     *
     * @var varchar survey_provisional
     */
    public function get_survey_provisional()
    {
        return $this->_survey_provisional;
    }

    /**
     * set survey_provisional method is stand for set the value of survey_provisional.
     *
     * @var varchar survey_provisional
     */
    public function set_survey_provisional($value)
    {
        $this->_survey_provisional = $value;
    }

    /**
     * get claim_remarks method is stand for get the value of claim_remarks.
     *
     * @var varchar claim_remarks
     */
    public function get_claim_remarks()
    {
        return $this->_claim_remarks;
    }

    /**
     * set claim_remarks method is stand for set the value of claim_remarks.
     *
     * @var varchar claim_remarks
     */
    public function set_claim_remarks($value)
    {
        $this->_claim_remarks = $value;
    }

    /**
     * get status method is stand for get the value of status.
     *
     * @var varchar status
     */
    public function get_status()
    {
        return $this->_status;
    }

    /**
     * set status method is stand for set the value of status.
     *
     * @var varchar status
     */
    public function set_status($value)
    {
        $this->_status = $value;
    }

    /**
     * get survey_date method is stand for get the value of survey_date.
     *
     * @var date survey_date
     */
    public function get_survey_date()
    {
        return date("d-M-Y", strtotime($this->_survey_date));
    }

    /**
     * set survey_date method is stand for set the value of survey_date.
     *
     * @var date survey_date
     */
    public function set_survey_date($value)
    {
        $this->_survey_date = date("Y-m-d", strtotime($value));
    }

    /**
     * get age_month method is stand for get the value of age_month.
     *
     * @var int age_month
     */
    public function get_age_month()
    {
        return (int) $this->_age_month;
    }

    /**
     * set age_month method is stand for set the value of age_month.
     *
     * @var int age_month
     */
    public function set_age_month($value)
    {
        $this->_age_month = (int) $value;
    }
    
    public function get_claim_amount_claimed() 
    {
        return $this->_claim_amount_claimed;
    }

    public function set_claim_amount_claimed($_claim_amount_claimed) 
    {
        $this->_claim_amount_claimed = $_claim_amount_claimed;
    }
        
    public function get_claim_amount_gross() 
    {
        return $this->_claim_amount_gross;
    }

    public function set_claim_amount_gross($_claim_amount_gross) 
    {
        $this->_claim_amount_gross = $_claim_amount_gross;
    }

    public function get_claim_amount_pay() 
    {
        return $this->_claim_amount_pay;
    }

    public function set_claim_amount_pay($_claim_amount_pay) 
    {
        $this->_claim_amount_pay = $_claim_amount_pay;
    }
    
    public function get_claim_reports() 
    {
        return $this->_claim_reports;
    }

    public function set_claim_reports($_claim_reports) 
    {
        $this->_claim_reports = $_claim_reports;
    }
    
    /**
     * get claim_user method is stand for get the value of claim_user.
     *
     * @var varchar claim_user
     */
    public function get_claim_user()
    {
        return $this->_claim_user;
    }

    /**
     * set claim_user method is stand for set the value of claim_user.
     *
     * @var varchar claim_user
     */
    public function set_claim_user($value)
    {
        $this->_claim_user = $value;
    }

    /**
     * get claim_updated_date method is stand for get the value of claim_updated_date.
     *
     * @var datetime claim_updated_date
     */
    public function get_claim_updated_date()
    {
        return $this->_claim_updated_date;
    }

    /**
     * set claim_updated_date method is stand for set the value of claim_updated_date.
     *
     * @var datetime claim_updated_date
     */
    public function set_claim_updated_date($value)
    {
        $this->_claim_updated_date = $value;
    }

    /**
     * get claim_created_date method is stand for get the value of claim_created_date.
     *
     * @var timestamp claim_created_date
     */
    public function get_claim_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_claim_created_date));
    }

    /**
     * set claim_created_date method is stand for set the value of claim_created_date.
     *
     * @var timestamp claim_created_date
     */
    public function set_claim_created_date($value)
    {
        $this->_claim_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_claim by set id thru constructor.
     *
     * @var int id
     * @var varchar claim_num
     * @var varchar claim_fy
     * @var varchar claim_type
     * @var varchar claim_loss_type
     * @var varchar claim_loss_nature
     * @var varchar department
     * @var varchar policy
     * @var varchar policy_number
     * @var varchar insurance_company
     * @var int claim_insured
     * @var varchar insured
     * @var varchar estimated_loss
     * @var varchar material_loss
     * @var int ho_id
     * @var varchar ho_address
     * @var int division_id
     * @var varchar division_address
     * @var int region_id
     * @var varchar region_address
     * @var int bo_id
     * @var varchar bo_address
     * @var varchar survey_provisional
     * @var varchar claim_remarks
     * @var varchar status
     * @var date survey_date
     * @var int age_month
     * @var datetime claim_updated_date
     * @var timestamp claim_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_claim_num($row->claim_num);
          $this->set_claim_ref_num($row->claim_ref_num);
          $this->set_claim_fy($row->claim_fy);
          $this->set_claim_type($row->claim_type);
          $this->set_claim_loss_time($row->claim_loss_time);
          $this->set_claim_loss_type($row->claim_loss_type);
          $this->set_claim_loss_nature($row->claim_loss_nature);
          $this->set_department($row->department);
          $this->set_policy($row->policy);
          $this->set_policy_number($row->policy_number);
          $this->set_insurance_company($row->insurance_company);
          $this->set_claim_insured($row->claim_insured);
          $this->set_insured($row->insured);
          $this->set_estimated_loss($row->estimated_loss);
          $this->set_material_loss($row->material_loss);
          $this->set_ho_id($row->ho_id);
          $this->set_ho_address($row->ho_address);
          $this->set_division_id($row->division_id);
          $this->set_division_address($row->division_address);
          $this->set_region_id($row->region_id);
          $this->set_region_address($row->region_address);
          $this->set_bo_id($row->bo_id);
          $this->set_bo_address($row->bo_address);
          $this->set_survey_provisional($row->survey_provisional);
          $this->set_claim_remarks($row->claim_remarks);
          $this->set_status($row->status);
          $this->set_survey_date($row->survey_date);
          $this->set_age_month($row->age_month);
          $this->set_claim_amount_claimed($row->claim_amount_claimed);
          $this->set_claim_amount_gross($row->claim_amount_gross);
          $this->set_claim_amount_pay($row->claim_amount_pay);
          $this->set_claim_reports($row->claim_reports);
          $this->set_claim_user($row->claim_user);
          $this->set_claim_updated_date($row->claim_updated_date);
          $this->set_claim_created_date($row->claim_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar claim_num
     * @var varchar claim_fy
     * @var varchar claim_type
     * @var varchar claim_loss_type
     * @var varchar claim_loss_nature
     * @var varchar department
     * @var varchar policy
     * @var varchar policy_number
     * @var varchar insurance_company
     * @var int claim_insured
     * @var varchar insured
     * @var varchar estimated_loss
     * @var varchar material_loss
     * @var int ho_id
     * @var varchar ho_address
     * @var int division_id
     * @var varchar division_address
     * @var int region_id
     * @var varchar region_address
     * @var int bo_id
     * @var varchar bo_address
     * @var varchar survey_provisional
     * @var varchar claim_remarks
     * @var varchar status
     * @var date survey_date
     * @var int age_month
     * @var datetime claim_updated_date
     */
    public function save()
    {
        $data = array(
          "id" => $this->get_id(),  
          "claim_num" => $this->get_claim_num(),
          "claim_ref_num" => $this->get_claim_ref_num(),
          "claim_fy" => $this->get_claim_fy(),
          "claim_type" => $this->get_claim_type(),
          "claim_loss_time" => $this->get_claim_loss_time(),
          "claim_loss_type" => $this->get_claim_loss_type(),
          "claim_loss_nature" => $this->get_claim_loss_nature(),
          "department" => $this->get_department(),
          "policy" => $this->get_policy(),
          "policy_number" => $this->get_policy_number(),
          "insurance_company" => $this->get_insurance_company(),
          "claim_insured" => $this->get_claim_insured(),
          "insured" => $this->get_insured(),
          "estimated_loss" => $this->get_estimated_loss(),
          "material_loss" => $this->get_material_loss(),
          "ho_id" => $this->get_ho_id(),
          "ho_address" => $this->get_ho_address(),
          "division_id" => $this->get_division_id(),
          "division_address" => $this->get_division_address(),
          "region_id" => $this->get_region_id(),
          "region_address" => $this->get_region_address(),
          "bo_id" => $this->get_bo_id(),
          "bo_address" => $this->get_bo_address(),
          "survey_provisional" => $this->get_survey_provisional(),
          "claim_remarks" => $this->get_claim_remarks(),
          "status" => $this->get_status(),
          "survey_date" => date("Y-m-d", strtotime($this->get_survey_date())),
          "age_month" => $this->get_age_month(),
          "claim_amount_claimed" => $this->get_claim_amount_claimed(),  
          "claim_amount_gross" => $this->get_claim_amount_gross(),  
          "claim_amount_pay" => $this->get_claim_amount_pay(),
          "claim_reports" => $this->get_claim_reports(), 
          "claim_user" => $this->get_claim_user(),
          "claim_updated_date" => $this->get_claim_updated_date());
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if(null == $row || empty($row))
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_claim by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select()->order('claim_loss_time desc');
        return $select;
    }

    /**
     * get_claim_num_by_id method is stand for get the value ofclaim_num By id.
     *
     * @var varchar claim_num
     */
    public function get_claim_num_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_num();
    }

    /**
     * get_claim_ref_num_by_id method is stand for get the value ofclaim_num By id.
     *
     * @var varchar claim_ref_num
     */
    public function get_claim_ref_num_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_ref_num();
    }

    /**
     * get_claim_fy_by_id method is stand for get the value ofclaim_fy By id.
     *
     * @var varchar claim_fy
     */
    public function get_claim_fy_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_fy();
    }

    /**
     * get_claim_type_by_id method is stand for get the value ofclaim_type By id.
     *
     * @var varchar claim_type
     */
    public function get_claim_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_type();
    }

    /**
     * get_claim_loss_type_by_id method is stand for get the value ofclaim_loss_type By
     * id.
     *
     * @var varchar claim_loss_type
     */
    public function get_claim_loss_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_loss_type();
    }

    /**
     * get_claim_loss_nature_by_id method is stand for get the value
     * ofclaim_loss_nature By id.
     *
     * @var varchar claim_loss_nature
     */
    public function get_claim_loss_nature_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_loss_nature();
    }

    /**
     * get_department_by_id method is stand for get the value ofdepartment By id.
     *
     * @var varchar department
     */
    public function get_department_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_department();
    }

    /**
     * get_policy_by_id method is stand for get the value ofpolicy By id.
     *
     * @var varchar policy
     */
    public function get_policy_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_policy();
    }

    /**
     * get_policy_number_by_id method is stand for get the value ofpolicy_number By id.
     *
     * @var varchar policy_number
     */
    public function get_policy_number_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_policy_number();
    }

    /**
     * get_insurance_company_by_id method is stand for get the value
     * ofinsurance_company By id.
     *
     * @var varchar insurance_company
     */
    public function get_insurance_company_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_insurance_company();
    }

    /**
     * get_claim_insured_by_id method is stand for get the value ofclaim_insured By id.
     *
     * @var int claim_insured
     */
    public function get_claim_insured_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_claim_insured();
    }

    /**
     * get_insured_by_id method is stand for get the value ofinsured By id.
     *
     * @var varchar insured
     */
    public function get_insured_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_insured();
    }

    /**
     * get_estimated_loss_by_id method is stand for get the value ofestimated_loss By
     * id.
     *
     * @var varchar estimated_loss
     */
    public function get_estimated_loss_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_estimated_loss();
    }

    /**
     * get_material_loss_by_id method is stand for get the value ofmaterial_loss By id.
     *
     * @var varchar material_loss
     */
    public function get_material_loss_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_material_loss();
    }

    /**
     * get_ho_id_by_id method is stand for get the value ofho_id By id.
     *
     * @var int ho_id
     */
    public function get_ho_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_ho_id();
    }

    /**
     * get_ho_address_by_id method is stand for get the value ofho_address By id.
     *
     * @var varchar ho_address
     */
    public function get_ho_address_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_ho_address();
    }

    /**
     * get_division_id_by_id method is stand for get the value ofdivision_id By id.
     *
     * @var int division_id
     */
    public function get_division_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_division_id();
    }

    /**
     * get_division_address_by_id method is stand for get the value ofdivision_address
     * By id.
     *
     * @var varchar division_address
     */
    public function get_division_address_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_division_address();
    }

    /**
     * get_region_id_by_id method is stand for get the value ofregion_id By id.
     *
     * @var int region_id
     */
    public function get_region_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_region_id();
    }

    /**
     * get_region_address_by_id method is stand for get the value ofregion_address By
     * id.
     *
     * @var varchar region_address
     */
    public function get_region_address_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_region_address();
    }

    /**
     * get_bo_id_by_id method is stand for get the value ofbo_id By id.
     *
     * @var int bo_id
     */
    public function get_bo_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_bo_id();
    }

    /**
     * get_bo_address_by_id method is stand for get the value ofbo_address By id.
     *
     * @var varchar bo_address
     */
    public function get_bo_address_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_bo_address();
    }

    /**
     * get_survey_provisional_by_id method is stand for get the value
     * ofsurvey_provisional By id.
     *
     * @var varchar survey_provisional
     */
    public function get_survey_provisional_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_survey_provisional();
    }

    /**
     * get_claim_remarks_by_id method is stand for get the value ofclaim_remarks By id.
     *
     * @var varchar claim_remarks
     */
    public function get_claim_remarks_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_remarks();
    }

    /**
     * get_status_by_id method is stand for get the value ofstatus By id.
     *
     * @var varchar status
     */
    public function get_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_status();
    }

    /**
     * get_survey_date_by_id method is stand for get the value ofsurvey_date By id.
     *
     * @var date survey_date
     */
    public function get_survey_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y", strtotime($this->get_survey_date()));
    }

    /**
     * get_age_month_by_id method is stand for get the value ofage_month By id.
     *
     * @var int age_month
     */
    public function get_age_month_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_age_month();
    }

    /**
     * get_claim_updated_date_by_id method is stand for get the value
     * ofclaim_updated_date By id.
     *
     * @var datetime claim_updated_date
     */
    public function get_claim_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_claim_updated_date();
    }

    /**
     * get_claim_created_date_by_id method is stand for get the value
     * ofclaim_created_date By id.
     *
     * @var timestamp claim_created_date
     */
    public function get_claim_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_claim_created_date()));
    }


}
