<?php

class Application_Model_Product extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_products';

    private $_id = null;

    private $_product_name = null;

    private $_product_tag_line = null;

    private $_product_img = null;

    private $_product_category = null;

    private $_product_type = null;

    private $_product_qty = null;

    private $_product_desc = null;

    private $_product_uses = null;

    private $_product_action = null;

    private $_product_precaution = null;

    private $_product_side_effect = null;

    private $_product_meta_key = null;

    private $_product_meta_desc = null;

    private $_product_url = null;

    private $_product_status = null;

    private $_product_updated_by = null;

    private $_product_updated_date = null;

    private $_product_created_by = null;

    private $_product_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get product_name method is stand for get the value of product_name.
     *
     * @var varchar product_name
     */
    public function get_product_name()
    {
        return $this->_product_name;
    }

    /**
     * set product_name method is stand for set the value of product_name.
     *
     * @var varchar product_name
     */
    public function set_product_name($value)
    {
        $this->_product_name = $value;
    }

    /**
     * get product_tag_line method is stand for get the value of product_tag_line.
     *
     * @var varchar product_tag_line
     */
    public function get_product_tag_line()
    {
        return $this->_product_tag_line;
    }

    /**
     * set product_tag_line method is stand for set the value of product_tag_line.
     *
     * @var varchar product_tag_line
     */
    public function set_product_tag_line($value)
    {
        $this->_product_tag_line = $value;
    }

    /**
     * get product_img method is stand for get the value of product_img.
     *
     * @var varchar product_img
     */
    public function get_product_img()
    {
        return $this->_product_img;
    }

    /**
     * set product_img method is stand for set the value of product_img.
     *
     * @var varchar product_img
     */
    public function set_product_img($value)
    {
        $this->_product_img = $value;
    }

    /**
     * get product_category method is stand for get the value of product_category.
     *
     * @var int product_category
     */
    public function get_product_category()
    {
        return (int) $this->_product_category;
    }

    /**
     * set product_category method is stand for set the value of product_category.
     *
     * @var int product_category
     */
    public function set_product_category($value)
    {
        $this->_product_category = (int) $value;
    }

    /**
     * get product_type method is stand for get the value of product_type.
     *
     * @var varchar product_type
     */
    public function get_product_type()
    {
        return $this->_product_type;
    }

    /**
     * set product_type method is stand for set the value of product_type.
     *
     * @var varchar product_type
     */
    public function set_product_type($value)
    {
        $this->_product_type = $value;
    }

    /**
     * get product_qty method is stand for get the value of product_qty.
     *
     * @var varchar product_qty
     */
    public function get_product_qty()
    {
        return $this->_product_qty;
    }

    /**
     * set product_qty method is stand for set the value of product_qty.
     *
     * @var varchar product_qty
     */
    public function set_product_qty($value)
    {
        $this->_product_qty = $value;
    }

    /**
     * get product_desc method is stand for get the value of product_desc.
     *
     * @var text product_desc
     */
    public function get_product_desc()
    {
        return $this->_product_desc;
    }

    /**
     * set product_desc method is stand for set the value of product_desc.
     *
     * @var text product_desc
     */
    public function set_product_desc($value)
    {
        $this->_product_desc = $value;
    }

    /**
     * get product_uses method is stand for get the value of product_uses.
     *
     * @var text product_uses
     */
    public function get_product_uses()
    {
        return $this->_product_uses;
    }

    /**
     * set product_uses method is stand for set the value of product_uses.
     *
     * @var text product_uses
     */
    public function set_product_uses($value)
    {
        $this->_product_uses = $value;
    }

    /**
     * get product_action method is stand for get the value of product_action.
     *
     * @var text product_action
     */
    public function get_product_action()
    {
        return $this->_product_action;
    }

    /**
     * set product_action method is stand for set the value of product_action.
     *
     * @var text product_action
     */
    public function set_product_action($value)
    {
        $this->_product_action = $value;
    }

    /**
     * get product_precaution method is stand for get the value of product_precaution.
     *
     * @var text product_precaution
     */
    public function get_product_precaution()
    {
        return $this->_product_precaution;
    }

    /**
     * set product_precaution method is stand for set the value of product_precaution.
     *
     * @var text product_precaution
     */
    public function set_product_precaution($value)
    {
        $this->_product_precaution = $value;
    }

    /**
     * get product_side_effect method is stand for get the value of
     * product_side_effect.
     *
     * @var text product_side_effect
     */
    public function get_product_side_effect()
    {
        return $this->_product_side_effect;
    }

    /**
     * set product_side_effect method is stand for set the value of
     * product_side_effect.
     *
     * @var text product_side_effect
     */
    public function set_product_side_effect($value)
    {
        $this->_product_side_effect = $value;
    }

    /**
     * get product_meta_key method is stand for get the value of product_meta_key.
     *
     * @var varchar product_meta_key
     */
    public function get_product_meta_key()
    {
        return $this->_product_meta_key;
    }

    /**
     * set product_meta_key method is stand for set the value of product_meta_key.
     *
     * @var varchar product_meta_key
     */
    public function set_product_meta_key($value)
    {
        $this->_product_meta_key = $value;
    }

    /**
     * get product_meta_desc method is stand for get the value of product_meta_desc.
     *
     * @var varchar product_meta_desc
     */
    public function get_product_meta_desc()
    {
        return $this->_product_meta_desc;
    }

    /**
     * set product_meta_desc method is stand for set the value of product_meta_desc.
     *
     * @var varchar product_meta_desc
     */
    public function set_product_meta_desc($value)
    {
        $this->_product_meta_desc = $value;
    }

    /**
     * get product_url method is stand for get the value of product_url.
     *
     * @var varchar product_url
     */
    public function get_product_url()
    {
        return $this->_product_url;
    }

    /**
     * set product_url method is stand for set the value of product_url.
     *
     * @var varchar product_url
     */
    public function set_product_url($value)
    {
        $this->_product_url = $value;
    }

    /**
     * get product_status method is stand for get the value of product_status.
     *
     * @var varchar product_status
     */
    public function get_product_status()
    {
        return $this->_product_status;
    }

    /**
     * set product_status method is stand for set the value of product_status.
     *
     * @var varchar product_status
     */
    public function set_product_status($value)
    {
        $this->_product_status = $value;
    }

    /**
     * get product_updated_by method is stand for get the value of product_updated_by.
     *
     * @var int product_updated_by
     */
    public function get_product_updated_by()
    {
        return (int) $this->_product_updated_by;
    }

    /**
     * set product_updated_by method is stand for set the value of product_updated_by.
     *
     * @var int product_updated_by
     */
    public function set_product_updated_by($value)
    {
        $this->_product_updated_by = (int) $value;
    }

    /**
     * get product_updated_date method is stand for get the value of
     * product_updated_date.
     *
     * @var timestamp product_updated_date
     */
    public function get_product_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_product_updated_date));
    }

    /**
     * set product_updated_date method is stand for set the value of
     * product_updated_date.
     *
     * @var timestamp product_updated_date
     */
    public function set_product_updated_date($value)
    {
        $this->_product_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get product_created_by method is stand for get the value of product_created_by.
     *
     * @var int product_created_by
     */
    public function get_product_created_by()
    {
        return (int) $this->_product_created_by;
    }

    /**
     * set product_created_by method is stand for set the value of product_created_by.
     *
     * @var int product_created_by
     */
    public function set_product_created_by($value)
    {
        $this->_product_created_by = (int) $value;
    }

    /**
     * get product_created_date method is stand for get the value of
     * product_created_date.
     *
     * @var timestamp product_created_date
     */
    public function get_product_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_product_created_date));
    }

    /**
     * set product_created_date method is stand for set the value of
     * product_created_date.
     *
     * @var timestamp product_created_date
     */
    public function set_product_created_date($value)
    {
        $this->_product_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_products by set id thru constructor.
     *
     * @var int id
     * @var varchar product_name
     * @var varchar product_tag_line
     * @var varchar product_img
     * @var int product_category
     * @var varchar product_type
     * @var varchar product_qty
     * @var text product_desc
     * @var text product_uses
     * @var text product_action
     * @var text product_precaution
     * @var text product_side_effect
     * @var varchar product_meta_key
     * @var varchar product_meta_desc
     * @var varchar product_url
     * @var varchar product_status
     * @var int product_updated_by
     * @var timestamp product_updated_date
     * @var int product_created_by
     * @var timestamp product_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_product_name($row->product_name);
          $this->set_product_tag_line($row->product_tag_line);
          $this->set_product_img($row->product_img);
          $this->set_product_category($row->product_category);
          $this->set_product_type($row->product_type);
          $this->set_product_qty($row->product_qty);
          $this->set_product_desc($row->product_desc);
          $this->set_product_uses($row->product_uses);
          $this->set_product_action($row->product_action);
          $this->set_product_precaution($row->product_precaution);
          $this->set_product_side_effect($row->product_side_effect);
          $this->set_product_meta_key($row->product_meta_key);
          $this->set_product_meta_desc($row->product_meta_desc);
          $this->set_product_url($row->product_url);
          $this->set_product_status($row->product_status);
          $this->set_product_updated_by($row->product_updated_by);
          $this->set_product_updated_date($row->product_updated_date);
          $this->set_product_created_by($row->product_created_by);
          $this->set_product_created_date($row->product_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar product_name
     * @var varchar product_tag_line
     * @var varchar product_img
     * @var int product_category
     * @var varchar product_type
     * @var varchar product_qty
     * @var text product_desc
     * @var text product_uses
     * @var text product_action
     * @var text product_precaution
     * @var text product_side_effect
     * @var varchar product_meta_key
     * @var varchar product_meta_desc
     * @var varchar product_url
     * @var varchar product_status
     * @var int product_updated_by
     * @var int product_created_by
     */
    public function save()
    {
        $data = array(
          "product_name" => $this->get_product_name(),
          "product_tag_line" => $this->get_product_tag_line(),
          "product_img" => $this->get_product_img(),
          "product_category" => $this->get_product_category(),
          "product_type" => $this->get_product_type(),
          "product_qty" => $this->get_product_qty(),
          "product_desc" => $this->get_product_desc(),
          "product_uses" => $this->get_product_uses(),
          "product_action" => $this->get_product_action(),
          "product_precaution" => $this->get_product_precaution(),
          "product_side_effect" => $this->get_product_side_effect(),
          "product_meta_key" => $this->get_product_meta_key(),
          "product_meta_desc" => $this->get_product_meta_desc(),
          "product_url" => $this->get_product_url(),
          "product_status" => $this->get_product_status(),
          "product_updated_by" => $this->get_product_updated_by(),
          "product_created_by" => $this->get_product_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_products by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_product_name_by_id method is stand for get the value ofproduct_name By id.
     *
     * @var varchar product_name
     */
    public function get_product_name_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_name();
    }

    /**
     * get_product_tag_line_by_id method is stand for get the value ofproduct_tag_line
     * By id.
     *
     * @var varchar product_tag_line
     */
    public function get_product_tag_line_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_tag_line();
    }

    /**
     * get_product_img_by_id method is stand for get the value ofproduct_img By id.
     *
     * @var varchar product_img
     */
    public function get_product_img_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_img();
    }

    /**
     * get_product_category_by_id method is stand for get the value ofproduct_category
     * By id.
     *
     * @var int product_category
     */
    public function get_product_category_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_product_category();
    }

    /**
     * get_product_type_by_id method is stand for get the value ofproduct_type By id.
     *
     * @var varchar product_type
     */
    public function get_product_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_type();
    }

    /**
     * get_product_qty_by_id method is stand for get the value ofproduct_qty By id.
     *
     * @var varchar product_qty
     */
    public function get_product_qty_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_qty();
    }

    /**
     * get_product_desc_by_id method is stand for get the value ofproduct_desc By id.
     *
     * @var text product_desc
     */
    public function get_product_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_desc();
    }

    /**
     * get_product_uses_by_id method is stand for get the value ofproduct_uses By id.
     *
     * @var text product_uses
     */
    public function get_product_uses_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_uses();
    }

    /**
     * get_product_action_by_id method is stand for get the value ofproduct_action By
     * id.
     *
     * @var text product_action
     */
    public function get_product_action_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_action();
    }

    /**
     * get_product_precaution_by_id method is stand for get the value
     * ofproduct_precaution By id.
     *
     * @var text product_precaution
     */
    public function get_product_precaution_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_precaution();
    }

    /**
     * get_product_side_effect_by_id method is stand for get the value
     * ofproduct_side_effect By id.
     *
     * @var text product_side_effect
     */
    public function get_product_side_effect_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_side_effect();
    }

    /**
     * get_product_meta_key_by_id method is stand for get the value ofproduct_meta_key
     * By id.
     *
     * @var varchar product_meta_key
     */
    public function get_product_meta_key_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_meta_key();
    }

    /**
     * get_product_meta_desc_by_id method is stand for get the value
     * ofproduct_meta_desc By id.
     *
     * @var varchar product_meta_desc
     */
    public function get_product_meta_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_meta_desc();
    }

    /**
     * get_product_url_by_id method is stand for get the value ofproduct_url By id.
     *
     * @var varchar product_url
     */
    public function get_product_url_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_url();
    }

    /**
     * get_product_status_by_id method is stand for get the value ofproduct_status By
     * id.
     *
     * @var varchar product_status
     */
    public function get_product_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_product_status();
    }

    /**
     * get_product_updated_by_by_id method is stand for get the value
     * ofproduct_updated_by By id.
     *
     * @var int product_updated_by
     */
    public function get_product_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_product_updated_by();
    }

    /**
     * get_product_updated_date_by_id method is stand for get the value
     * ofproduct_updated_date By id.
     *
     * @var timestamp product_updated_date
     */
    public function get_product_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_product_updated_date()));
    }

    /**
     * get_product_created_by_by_id method is stand for get the value
     * ofproduct_created_by By id.
     *
     * @var int product_created_by
     */
    public function get_product_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_product_created_by();
    }

    /**
     * get_product_created_date_by_id method is stand for get the value
     * ofproduct_created_date By id.
     *
     * @var timestamp product_created_date
     */
    public function get_product_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_product_created_date()));
    }


}
