<?php

class AppointmentController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax', 'consulting', 'sonipat', 'haryana', 'tax consultant', 'appointment', 'GST registration', 'tax assessment'); 
        $layout->assign('meta_desc', 'Book your appointment with M Goswami & Associates');
        $layout->assign('page_title', 'Book your appointment with M Goswami & Associates');
        
        if($this->getRequest()->isPost()){
            $data=$this->getRequest()->getPost();
            if(!empty($data) && !empty($data['name']) && !empty($data['email']) && !empty($data['phone']) && !empty($data['date'] && !empty($data['service']) && !empty($data['subject']))) {
                $obj_appoint = new Application_Model_AppointmentLogic(-1);
                $obj_appoint->set_appointment_name($data['name']);
                $obj_appoint->set_appointment_email($data['email']);
                $obj_appoint->set_appointment_phone($data['phone']);
                $obj_appoint->set_appointment_date(date('Y-m-d H:i:s', strtotime($data['date'])));
                $obj_appoint->set_appointment_service($data['service']);
                $obj_appoint->set_appointment_subject($data['subject']);
                $obj_appoint->set_appointment_message($data['message']);
                $obj_appoint->set_appointment_confirm(false);
                $obj_appoint->set_appointment_remarks();
                $obj_appoint->set_appointment_status('I');
                $obj_appoint->save();
                
                $msub = 'Appointment Booked with M Goswami & Associates';
                $mbody = '<p>Dear '.$obj_appoint->get_appointment_name().', </p><br /><p>Your appointment has been booked with M Goswami & Associates at '. $obj_appoint->get_appointment_date().'</p><br /><br /><p>We will wait for your presence.</p><br /><p>Thank You<br />--<br />Warm Regards,<br />Support Team<br />M Goswami & Associates</p>';

                $obj_mail = new Application_Model_Email_Util();
                $obj_mail->send($obj_appoint->get_appointment_email(), $msub, $mbody);
                
                $sess = new Zend_Session_Namespace("msg");
                $sess->msg = "Your appointment has been booked successfully!!!";
                $this->_redirect("dynasty/appointment/index");
            }else {
                $sess = new Zend_Session_Namespace("msg");
                $sess->error = "Sorry, your appointment has not been booked. Please contact to administrator.!!!";
                $this->_redirect("dynasty/appointment/index");
            }
        }
    }
    
}