<?php

class Application_Model_Expert extends Zend_Db_Table_Abstract
{
    
    protected $_name = 'asit_experts';
    
    private $_id = null;
    
    private $_expert_title = null;
    
    private $_expert_image = null;
    
    private $_expert_short_desc = null;
    
    private $_expert_desc = null;
    
    private $_expert_url = null;
    
    private $_expert_meta_key = null;
    
    private $_expert_meta_desc = null;
    
    private $_expert_status = null;
    
    private $_expert_updated_by = null;
    
    private $_expert_updated_date = null;
    
    private $_expert_created_by = null;
    
    private $_expert_created_date = null;
    
    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
            $this->fetch();
        }
    }
    
    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }
    
    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }
    
    /**
     * get expert_title method is stand for get the value of expert_title.
     *
     * @var varchar expert_title
     */
    public function get_expert_title()
    {
        return $this->_expert_title;
    }
    
    /**
     * set expert_title method is stand for set the value of expert_title.
     *
     * @var varchar expert_title
     */
    public function set_expert_title($value)
    {
        $this->_expert_title = $value;
    }
    
    /**
     * get expert_image method is stand for get the value of expert_image.
     *
     * @var varchar expert_image
     */
    public function get_expert_image()
    {
        return $this->_expert_image;
    }
    
    /**
     * set expert_image method is stand for set the value of expert_image.
     *
     * @var varchar expert_image
     */
    public function set_expert_image($value)
    {
        $this->_expert_image = $value;
    }
    
    /**
     * get expert_short_desc method is stand for get the value of expert_short_desc.
     *
     * @var varchar expert_short_desc
     */
    public function get_expert_short_desc()
    {
        return $this->_expert_short_desc;
    }
    
    /**
     * set expert_short_desc method is stand for set the value of expert_short_desc.
     *
     * @var varchar expert_short_desc
     */
    public function set_expert_short_desc($value)
    {
        $this->_expert_short_desc = $value;
    }
    
    /**
     * get expert_desc method is stand for get the value of expert_desc.
     *
     * @var text expert_desc
     */
    public function get_expert_desc()
    {
        return $this->_expert_desc;
    }
    
    /**
     * set expert_desc method is stand for set the value of expert_desc.
     *
     * @var text expert_desc
     */
    public function set_expert_desc($value)
    {
        $this->_expert_desc = $value;
    }
    
    /**
     * get expert_url method is stand for get the value of expert_url.
     *
     * @var varchar expert_url
     */
    public function get_expert_url()
    {
        return $this->_expert_url;
    }
    
    /**
     * set expert_url method is stand for set the value of expert_url.
     *
     * @var varchar expert_url
     */
    public function set_expert_url($value)
    {
        $this->_expert_url = $value;
    }
    
    /**
     * get expert_meta_key method is stand for get the value of expert_meta_key.
     *
     * @var varchar expert_meta_key
     */
    public function get_expert_meta_key()
    {
        return $this->_expert_meta_key;
    }
    
    /**
     * set expert_meta_key method is stand for set the value of expert_meta_key.
     *
     * @var varchar expert_meta_key
     */
    public function set_expert_meta_key($value)
    {
        $this->_expert_meta_key = $value;
    }
    
    /**
     * get expert_meta_desc method is stand for get the value of expert_meta_desc.
     *
     * @var varchar expert_meta_desc
     */
    public function get_expert_meta_desc()
    {
        return $this->_expert_meta_desc;
    }
    
    /**
     * set expert_meta_desc method is stand for set the value of expert_meta_desc.
     *
     * @var varchar expert_meta_desc
     */
    public function set_expert_meta_desc($value)
    {
        $this->_expert_meta_desc = $value;
    }
    
    /**
     * get expert_status method is stand for get the value of expert_status.
     *
     * @var varchar expert_status
     */
    public function get_expert_status()
    {
        return $this->_expert_status;
    }
    
    /**
     * set expert_status method is stand for set the value of expert_status.
     *
     * @var varchar expert_status
     */
    public function set_expert_status($value)
    {
        $this->_expert_status = $value;
    }
    
    /**
     * get expert_updated_by method is stand for get the value of expert_updated_by.
     *
     * @var int expert_updated_by
     */
    public function get_expert_updated_by()
    {
        return (int) $this->_expert_updated_by;
    }
    
    /**
     * set expert_updated_by method is stand for set the value of expert_updated_by.
     *
     * @var int expert_updated_by
     */
    public function set_expert_updated_by($value)
    {
        $this->_expert_updated_by = (int) $value;
    }
    
    /**
     * get expert_updated_date method is stand for get the value of expert_updated_date.
     *
     * @var timestamp expert_updated_date
     */
    public function get_expert_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_expert_updated_date));
    }
    
    /**
     * set expert_updated_date method is stand for set the value of expert_updated_date.
     *
     * @var timestamp expert_updated_date
     */
    public function set_expert_updated_date($value)
    {
        $this->_expert_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }
    
    /**
     * get expert_created_by method is stand for get the value of expert_created_by.
     *
     * @var int expert_created_by
     */
    public function get_expert_created_by()
    {
        return (int) $this->_expert_created_by;
    }
    
    /**
     * set expert_created_by method is stand for set the value of expert_created_by.
     *
     * @var int expert_created_by
     */
    public function set_expert_created_by($value)
    {
        $this->_expert_created_by = (int) $value;
    }
    
    /**
     * get expert_created_date method is stand for get the value of expert_created_date.
     *
     * @var timestamp expert_created_date
     */
    public function get_expert_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_expert_created_date));
    }
    
    /**
     * set expert_created_date method is stand for set the value of expert_created_date.
     *
     * @var timestamp expert_created_date
     */
    public function set_expert_created_date($value)
    {
        $this->_expert_created_date = date("Y-m-d H:i:s", strtotime($value));
    }
    
    /**
     * fetch data from asit_experts by set id thru constructor.
     *
     * @var int id
     * @var varchar expert_title
     * @var varchar expert_image
     * @var varchar expert_short_desc
     * @var text expert_desc
     * @var varchar expert_url
     * @var varchar expert_meta_key
     * @var varchar expert_meta_desc
     * @var varchar expert_status
     * @var int expert_updated_by
     * @var timestamp expert_updated_date
     * @var int expert_created_by
     * @var timestamp expert_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
            $this->set_id($row->id);
            $this->set_expert_title($row->expert_title);
            $this->set_expert_image($row->expert_image);
            $this->set_expert_short_desc($row->expert_short_desc);
            $this->set_expert_desc($row->expert_desc);
            $this->set_expert_url($row->expert_url);
            $this->set_expert_meta_key($row->expert_meta_key);
            $this->set_expert_meta_desc($row->expert_meta_desc);
            $this->set_expert_status($row->expert_status);
            $this->set_expert_updated_by($row->expert_updated_by);
            $this->set_expert_updated_date($row->expert_updated_date);
            $this->set_expert_created_by($row->expert_created_by);
            $this->set_expert_created_date($row->expert_created_date);
        }
    }
    
    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar expert_title
     * @var varchar expert_image
     * @var varchar expert_short_desc
     * @var text expert_desc
     * @var varchar expert_url
     * @var varchar expert_meta_key
     * @var varchar expert_meta_desc
     * @var varchar expert_status
     * @var int expert_updated_by
     * @var int expert_created_by
     */
    public function save()
    {
        $data = array(
            "expert_title" => $this->get_expert_title(),
            "expert_image" => $this->get_expert_image(),
            "expert_short_desc" => $this->get_expert_short_desc(),
            "expert_desc" => $this->get_expert_desc(),
            "expert_url" => $this->get_expert_url(),
            "expert_meta_key" => $this->get_expert_meta_key(),
            "expert_meta_desc" => $this->get_expert_meta_desc(),
            "expert_status" => $this->get_expert_status(),
            "expert_updated_by" => $this->get_expert_updated_by(),
            "expert_created_by" => $this->get_expert_created_by());
        if($this->get_id()==-1)
        {
            return $this->insert($data);
        }
        else
        {
            $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
            $this->update($data, $where);
        }
    }
    
    /**
     * remove method delete the record from asit_experts by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }
    
    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }
    
    /**
     * get_expert_title_by_id method is stand for get the value ofexpert_title By id.
     *
     * @var varchar expert_title
     */
    public function get_expert_title_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_title();
    }
    
    /**
     * get_expert_image_by_id method is stand for get the value ofexpert_image By id.
     *
     * @var varchar expert_image
     */
    public function get_expert_image_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_image();
    }
    
    /**
     * get_expert_short_desc_by_id method is stand for get the value ofexpert_short_desc By
     * id.
     *
     * @var varchar expert_short_desc
     */
    public function get_expert_short_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_short_desc();
    }
    
    /**
     * get_expert_desc_by_id method is stand for get the value ofexpert_desc By id.
     *
     * @var text expert_desc
     */
    public function get_expert_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_desc();
    }
    
    /**
     * get_expert_url_by_id method is stand for get the value ofexpert_url By id.
     *
     * @var varchar expert_url
     */
    public function get_expert_url_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_url();
    }
    
    /**
     * get_expert_meta_key_by_id method is stand for get the value ofexpert_meta_key By id.
     *
     * @var varchar expert_meta_key
     */
    public function get_expert_meta_key_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_meta_key();
    }
    
    /**
     * get_expert_meta_desc_by_id method is stand for get the value ofexpert_meta_desc By
     * id.
     *
     * @var varchar expert_meta_desc
     */
    public function get_expert_meta_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_meta_desc();
    }
    
    /**
     * get_expert_status_by_id method is stand for get the value ofexpert_status By id.
     *
     * @var varchar expert_status
     */
    public function get_expert_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_expert_status();
    }
    
    /**
     * get_expert_updated_by_by_id method is stand for get the value ofexpert_updated_by By
     * id.
     *
     * @var int expert_updated_by
     */
    public function get_expert_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_expert_updated_by();
    }
    
    /**
     * get_expert_updated_date_by_id method is stand for get the value
     * ofexpert_updated_date By id.
     *
     * @var timestamp expert_updated_date
     */
    public function get_expert_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_expert_updated_date()));
    }
    
    /**
     * get_expert_created_by_by_id method is stand for get the value ofexpert_created_by By
     * id.
     *
     * @var int expert_created_by
     */
    public function get_expert_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_expert_created_by();
    }
    
    /**
     * get_expert_created_date_by_id method is stand for get the value
     * ofexpert_created_date By id.
     *
     * @var timestamp expert_created_date
     */
    public function get_expert_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_expert_created_date()));
    }
    
    
}
