<?php

class Application_Model_IssueFile extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_issue_file';

    private $_id = null;

    private $_issue_title = null;

    private $_issue_description = null;

    private $_issue_type = null;

    private $_issue_claim_id = null;

    private $_issue_claim_num = null;

    private $_issue_priority = null;

    private $_issue_submit_type = null;

    private $_issue_submit_by = null;

    private $_issue_contact_name = null;

    private $_issue_contact_email = null;

    private $_issue_contact_phone = null;

    private $_issue_register_date = null;

    private $_issue_sync = null;

    private $_issue_created_by = null;

    private $_issue_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get issue_title method is stand for get the value of issue_title.
     *
     * @var varchar issue_title
     */
    public function get_issue_title()
    {
        return $this->_issue_title;
    }

    /**
     * set issue_title method is stand for set the value of issue_title.
     *
     * @var varchar issue_title
     */
    public function set_issue_title($value)
    {
        $this->_issue_title = $value;
    }

    /**
     * get issue_description method is stand for get the value of issue_description.
     *
     * @var text issue_description
     */
    public function get_issue_description()
    {
        return $this->_issue_description;
    }

    /**
     * set issue_description method is stand for set the value of issue_description.
     *
     * @var text issue_description
     */
    public function set_issue_description($value)
    {
        $this->_issue_description = $value;
    }

    /**
     * get issue_type method is stand for get the value of issue_type.
     *
     * @var varchar issue_type
     */
    public function get_issue_type()
    {
        return $this->_issue_type;
    }

    /**
     * set issue_type method is stand for set the value of issue_type.
     *
     * @var varchar issue_type
     */
    public function set_issue_type($value)
    {
        $this->_issue_type = $value;
    }

    /**
     * get issue_claim_id method is stand for get the value of issue_claim_id.
     *
     * @var int issue_claim_id
     */
    public function get_issue_claim_id()
    {
        return (int) $this->_issue_claim_id;
    }

    /**
     * set issue_claim_id method is stand for set the value of issue_claim_id.
     *
     * @var int issue_claim_id
     */
    public function set_issue_claim_id($value)
    {
        $this->_issue_claim_id = (int) $value;
    }

    /**
     * get issue_claim_num method is stand for get the value of issue_claim_num.
     *
     * @var varchar issue_claim_num
     */
    public function get_issue_claim_num()
    {
        return $this->_issue_claim_num;
    }

    /**
     * set issue_claim_num method is stand for set the value of issue_claim_num.
     *
     * @var varchar issue_claim_num
     */
    public function set_issue_claim_num($value)
    {
        $this->_issue_claim_num = $value;
    }

    /**
     * get issue_priority method is stand for get the value of issue_priority.
     *
     * @var varchar issue_priority
     */
    public function get_issue_priority()
    {
        return $this->_issue_priority;
    }

    /**
     * set issue_priority method is stand for set the value of issue_priority.
     *
     * @var varchar issue_priority
     */
    public function set_issue_priority($value)
    {
        $this->_issue_priority = $value;
    }

    /**
     * get issue_submit_type method is stand for get the value of issue_submit_type.
     *
     * @var varchar issue_submit_type
     */
    public function get_issue_submit_type()
    {
        return $this->_issue_submit_type;
    }

    /**
     * set issue_submit_type method is stand for set the value of issue_submit_type.
     *
     * @var varchar issue_submit_type
     */
    public function set_issue_submit_type($value)
    {
        $this->_issue_submit_type = $value;
    }

    /**
     * get issue_submit_by method is stand for get the value of issue_submit_by.
     *
     * @var int issue_submit_by
     */
    public function get_issue_submit_by()
    {
        return (int) $this->_issue_submit_by;
    }

    /**
     * set issue_submit_by method is stand for set the value of issue_submit_by.
     *
     * @var int issue_submit_by
     */
    public function set_issue_submit_by($value)
    {
        $this->_issue_submit_by = (int) $value;
    }

    /**
     * get issue_contact_name method is stand for get the value of issue_contact_name.
     *
     * @var varchar issue_contact_name
     */
    public function get_issue_contact_name()
    {
        return $this->_issue_contact_name;
    }

    /**
     * set issue_contact_name method is stand for set the value of issue_contact_name.
     *
     * @var varchar issue_contact_name
     */
    public function set_issue_contact_name($value)
    {
        $this->_issue_contact_name = $value;
    }

    /**
     * get issue_contact_email method is stand for get the value of
     * issue_contact_email.
     *
     * @var varchar issue_contact_email
     */
    public function get_issue_contact_email()
    {
        return $this->_issue_contact_email;
    }

    /**
     * set issue_contact_email method is stand for set the value of
     * issue_contact_email.
     *
     * @var varchar issue_contact_email
     */
    public function set_issue_contact_email($value)
    {
        $this->_issue_contact_email = $value;
    }

    /**
     * get issue_contact_phone method is stand for get the value of
     * issue_contact_phone.
     *
     * @var varchar issue_contact_phone
     */
    public function get_issue_contact_phone()
    {
        return $this->_issue_contact_phone;
    }

    /**
     * set issue_contact_phone method is stand for set the value of
     * issue_contact_phone.
     *
     * @var varchar issue_contact_phone
     */
    public function set_issue_contact_phone($value)
    {
        $this->_issue_contact_phone = $value;
    }

    /**
     * get issue_register_date method is stand for get the value of
     * issue_register_date.
     *
     * @var date issue_register_date
     */
    public function get_issue_register_date()
    {
        return date("d-M-Y", strtotime($this->_issue_register_date));
    }

    /**
     * set issue_register_date method is stand for set the value of
     * issue_register_date.
     *
     * @var date issue_register_date
     */
    public function set_issue_register_date($value)
    {
        $this->_issue_register_date = date("Y-m-d", strtotime($value));
    }

    /**
     * get issue_sync method is stand for get the value of issue_sync.
     *
     * @var tinyint issue_sync
     */
    public function get_issue_sync()
    {
        return $this->_issue_sync;
    }

    /**
     * set issue_sync method is stand for set the value of issue_sync.
     *
     * @var tinyint issue_sync
     */
    public function set_issue_sync($value)
    {
        $this->_issue_sync = $value;
    }

    /**
     * get issue_created_by method is stand for get the value of issue_created_by.
     *
     * @var int issue_created_by
     */
    public function get_issue_created_by()
    {
        return (int) $this->_issue_created_by;
    }

    /**
     * set issue_created_by method is stand for set the value of issue_created_by.
     *
     * @var int issue_created_by
     */
    public function set_issue_created_by($value)
    {
        $this->_issue_created_by = (int) $value;
    }

    /**
     * get issue_created_date method is stand for get the value of issue_created_date.
     *
     * @var timestamp issue_created_date
     */
    public function get_issue_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_issue_created_date));
    }

    /**
     * set issue_created_date method is stand for set the value of issue_created_date.
     *
     * @var timestamp issue_created_date
     */
    public function set_issue_created_date($value)
    {
        $this->_issue_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_issue_file by set id thru constructor.
     *
     * @var int id
     * @var varchar issue_title
     * @var text issue_description
     * @var varchar issue_type
     * @var int issue_claim_id
     * @var varchar issue_claim_num
     * @var varchar issue_priority
     * @var varchar issue_submit_type
     * @var int issue_submit_by
     * @var varchar issue_contact_name
     * @var varchar issue_contact_email
     * @var varchar issue_contact_phone
     * @var date issue_register_date
     * @var tinyint issue_sync
     * @var int issue_created_by
     * @var timestamp issue_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_issue_title($row->issue_title);
          $this->set_issue_description($row->issue_description);
          $this->set_issue_type($row->issue_type);
          $this->set_issue_claim_id($row->issue_claim_id);
          $this->set_issue_claim_num($row->issue_claim_num);
          $this->set_issue_priority($row->issue_priority);
          $this->set_issue_submit_type($row->issue_submit_type);
          $this->set_issue_submit_by($row->issue_submit_by);
          $this->set_issue_contact_name($row->issue_contact_name);
          $this->set_issue_contact_email($row->issue_contact_email);
          $this->set_issue_contact_phone($row->issue_contact_phone);
          $this->set_issue_register_date($row->issue_register_date);
          $this->set_issue_sync($row->issue_sync);
          $this->set_issue_created_by($row->issue_created_by);
          $this->set_issue_created_date($row->issue_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar issue_title
     * @var text issue_description
     * @var varchar issue_type
     * @var int issue_claim_id
     * @var varchar issue_claim_num
     * @var varchar issue_priority
     * @var varchar issue_submit_type
     * @var int issue_submit_by
     * @var varchar issue_contact_name
     * @var varchar issue_contact_email
     * @var varchar issue_contact_phone
     * @var date issue_register_date
     * @var tinyint issue_sync
     * @var int issue_created_by
     */
    public function save()
    {
        $data = array(
          "issue_title" => $this->get_issue_title(),
          "issue_description" => $this->get_issue_description(),
          "issue_type" => $this->get_issue_type(),
          "issue_claim_id" => $this->get_issue_claim_id(),
          "issue_claim_num" => $this->get_issue_claim_num(),
          "issue_priority" => $this->get_issue_priority(),
          "issue_submit_type" => $this->get_issue_submit_type(),
          "issue_submit_by" => $this->get_issue_submit_by(),
          "issue_contact_name" => $this->get_issue_contact_name(),
          "issue_contact_email" => $this->get_issue_contact_email(),
          "issue_contact_phone" => $this->get_issue_contact_phone(),
          "issue_register_date" => date("Y-m-d", strtotime($this->get_issue_register_date())),
          "issue_sync" => $this->get_issue_sync(),
          "issue_created_by" => $this->get_issue_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_issue_file by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_issue_title_by_id method is stand for get the value ofissue_title By id.
     *
     * @var varchar issue_title
     */
    public function get_issue_title_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_title();
    }

    /**
     * get_issue_description_by_id method is stand for get the value
     * ofissue_description By id.
     *
     * @var text issue_description
     */
    public function get_issue_description_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_description();
    }

    /**
     * get_issue_type_by_id method is stand for get the value ofissue_type By id.
     *
     * @var varchar issue_type
     */
    public function get_issue_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_type();
    }

    /**
     * get_issue_claim_id_by_id method is stand for get the value ofissue_claim_id By
     * id.
     *
     * @var int issue_claim_id
     */
    public function get_issue_claim_id_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_issue_claim_id();
    }

    /**
     * get_issue_claim_num_by_id method is stand for get the value ofissue_claim_num By
     * id.
     *
     * @var varchar issue_claim_num
     */
    public function get_issue_claim_num_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_claim_num();
    }

    /**
     * get_issue_priority_by_id method is stand for get the value ofissue_priority By
     * id.
     *
     * @var varchar issue_priority
     */
    public function get_issue_priority_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_priority();
    }

    /**
     * get_issue_submit_type_by_id method is stand for get the value
     * ofissue_submit_type By id.
     *
     * @var varchar issue_submit_type
     */
    public function get_issue_submit_type_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_submit_type();
    }

    /**
     * get_issue_submit_by_by_id method is stand for get the value ofissue_submit_by By
     * id.
     *
     * @var int issue_submit_by
     */
    public function get_issue_submit_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_issue_submit_by();
    }

    /**
     * get_issue_contact_name_by_id method is stand for get the value
     * ofissue_contact_name By id.
     *
     * @var varchar issue_contact_name
     */
    public function get_issue_contact_name_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_contact_name();
    }

    /**
     * get_issue_contact_email_by_id method is stand for get the value
     * ofissue_contact_email By id.
     *
     * @var varchar issue_contact_email
     */
    public function get_issue_contact_email_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_contact_email();
    }

    /**
     * get_issue_contact_phone_by_id method is stand for get the value
     * ofissue_contact_phone By id.
     *
     * @var varchar issue_contact_phone
     */
    public function get_issue_contact_phone_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_contact_phone();
    }

    /**
     * get_issue_register_date_by_id method is stand for get the value
     * ofissue_register_date By id.
     *
     * @var date issue_register_date
     */
    public function get_issue_register_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y", strtotime($this->get_issue_register_date()));
    }

    /**
     * get_issue_sync_by_id method is stand for get the value ofissue_sync By id.
     *
     * @var tinyint issue_sync
     */
    public function get_issue_sync_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_issue_sync();
    }

    /**
     * get_issue_created_by_by_id method is stand for get the value ofissue_created_by
     * By id.
     *
     * @var int issue_created_by
     */
    public function get_issue_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_issue_created_by();
    }

    /**
     * get_issue_created_date_by_id method is stand for get the value
     * ofissue_created_date By id.
     *
     * @var timestamp issue_created_date
     */
    public function get_issue_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_issue_created_date()));
    }


}
