<?php

class Application_Model_Layout_UrlIntercept
{
    
   public function intercept()
   {
       
        $baseUrl = new Zend_View_Helper_BaseUrl();
        
        $ctrl  = Zend_Controller_Front::getInstance();
        $router=$ctrl->getRouter();

        $route['login']=new Zend_Controller_Router_Route('login',array('module'=>'default', 'controller'=>'index','action'=>'login'));
        $router->addRoute('login',$route['login']);
        
        $route['logout']=new Zend_Controller_Router_Route('logout',array('module'=>'default', 'controller'=>'index','action'=>'logout'));
        $router->addRoute('logout',$route['logout']);
        
        $route['category']=new Zend_Controller_Router_Route('category/:cat',array('module'=>'default', 'controller'=>'list','action'=>'filter'));
        $router->addRoute('category',$route['category']);

        $route['city']=new Zend_Controller_Router_Route('city/:ct',array('module'=>'default', 'controller'=>'list','action'=>'filter'));
        $router->addRoute('city',$route['city']);

        $route['service']=new Zend_Controller_Router_Route('service/:url',array('module'=>'default', 'controller'=>'service', 'action'=>'index'));
        $router->addRoute('service',$route['service']);

        $route['page']=new Zend_Controller_Router_Route(':url',array('module'=>'default', 'controller'=>'page', 'action'=>'index'));
        $router->addRoute('page',$route['page']);

        $route['appointment']=new Zend_Controller_Router_Route('appointment',array('module'=>'default', 'controller'=>'index', 'action'=>'appointment'));
        $router->addRoute('appointment',$route['appointment']);

        $route['search']=new Zend_Controller_Router_Route('search',array('module'=>'default', 'controller'=>'list','action'=>'filter'));
        $router->addRoute('search',$route['search']);

        $route['contact']=new Zend_Controller_Router_Route('contact-us',array('module'=>'default', 'controller'=>'index','action'=>'contact'));
        $router->addRoute('contact',$route['contact']);

        $route['blog']=new Zend_Controller_Router_Route('blog',array('module'=>'default', 'controller'=>'blog','action'=>'index'));
        $router->addRoute('blog',$route['blog']);
        
        $route['blog1']=new Zend_Controller_Router_Route('blog/category/:cat',array('module'=>'default', 'controller'=>'blog','action'=>'index'));
        $router->addRoute('blog1',$route['blog1']);
        
        $route['blog2']=new Zend_Controller_Router_Route('blog/archive/:month',array('module'=>'default', 'controller'=>'blog','action'=>'index'));
        $router->addRoute('blog2',$route['blog2']);
        
        $route['blogView']=new Zend_Controller_Router_Route('blog/:url',array('module'=>'default', 'controller'=>'blog','action'=>'view'));
        $router->addRoute('blogView',$route['blogView']);
        
        $route['index']=new Zend_Controller_Router_Route('index',array('module'=>'default', 'controller'=>'index','action'=>'index'));
        $router->addRoute('index',$route['index']);
        
        $route['download']=new Zend_Controller_Router_Route('download/:folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download',$route['download']);

        $route['download1']=new Zend_Controller_Router_Route('download/:folder/:sub_folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download1',$route['download1']);

        $route['download2']=new Zend_Controller_Router_Route('download/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download2',$route['download2']);
        
        $route['download3']=new Zend_Controller_Router_Route('download/:folder/:sub_folder/:sub_sub_folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download3',$route['download3']);
        
        $route['img']=new Zend_Controller_Router_Route('img/:folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img',$route['img']);

        $route['img1']=new Zend_Controller_Router_Route('img/:folder/:sub_folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img1',$route['img1']);

        $route['img3']=new Zend_Controller_Router_Route('img/:folder/:sub_folder/:sub_sub_folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img3',$route['img3']);

        $route['img2']=new Zend_Controller_Router_Route('img/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img2',$route['img2']);
        
        $route['gallery']=new Zend_Controller_Router_Route('gallery',array('module'=>'default', 'controller'=>'gallery','action'=>'index'));
        $router->addRoute('gallery',$route['gallery']);

        $route['dynasty']=new Zend_Controller_Router_Route('dynasty',array('module'=>'dynasty', 'controller'=>'index','action'=>'index'));
        $router->addRoute('dynasty',$route['dynasty']);
        
        $route['product']=new Zend_Controller_Router_Route('product/:cat',array('module'=>'default', 'controller'=>'product', 'action'=>'index'));
        $router->addRoute('product',$route['product']);
        
        $route['product1']=new Zend_Controller_Router_Route('product/:cat/:url',array('module'=>'default', 'controller'=>'product', 'action'=>'view'));
        $router->addRoute('product1',$route['product1']);
        
        $route['tm']=new Zend_Controller_Router_Route('testimonial',array('module'=>'default', 'controller'=>'index', 'action'=>'testimonial'));
        $router->addRoute('tm',$route['tm']);
   }
   
}

