<?php

class Dynasty_CalendarController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        
    }
    
    public function eventsAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Dashboard")) {
            $this->_helper->layout()->disableLayout();
            $start = date('Y-m-d', $this->_getParam('start')); 
            $end = date('Y-m-d', $this->_getParam('end')); 

            /*$user = new Application_Model_UserLogic(-1);
            
            $obj_todo = new Application_Model_TodoLogic(-1);
            $todos = $obj_todo->getActiveTodosByUser($user->getLoggedInUserId(), $start, $end);

            $obj_work = new Application_Model_WorkLogic(-1);
            $works = $obj_work->getActiveWorksByUser($start, $end);*/
            
            $obj_appoint = new Application_Model_AppointmentLogic(-1);
            $lists = $obj_appoint->getAppointmentsOfMonth($start, $end);
            
            $baseUrl = new Zend_View_Helper_BaseUrl();
            
            $events = array();
            
            foreach($lists as $list)
            {
                $enc = new Application_Model_Util_Encrypt();
                $url = $baseUrl->baseUrl('dynasty/appointment/edit/id/'.$enc->hideContent($list->id));
                
                if($list->appointment_status == 'A') {
                    $className = 'fc-event-green';
                }else {
                    $className = 'fc-event-red';
                }
                
                $final = array();
                $final['id'] = $list->id;
                $final['title'] = $list->appointment_name.' Appointment';
                $final['start'] = $list->appointment_date;
                $final['end'] = $list->appointment_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }

            /* foreach($todos as $todo)
            {
                $url = $baseUrl->baseUrl('todo/edit/id/'.$todo->id);
                $className = (($todo->todo_to_date < $date) ? 'fc-event-grey' : (($todo->todo_from_date > $date) ? 'fc-event-green' : 'fc-event-skin'));
                
                $final = array();
                $final['id'] = $todo->id;
                $final['title'] = $todo->todo_title;
                $final['start'] = $todo->todo_from_date;
                $final['end'] = $todo->todo_to_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            }

            foreach($works as $work)
            {
                $url = $baseUrl->baseUrl('work-status/index/id/'.$work->id);
                $className = null;
                
                if($work->work_status == 'Complete') { $className = 'fc-event-grey'; }
                else if($work->work_status == 'Assigned' && $work->work_from_date > $date) { $className = 'fc-event-green'; }
                else if($work->work_status == 'Assigned' && $work->work_from_date <= $date && $work->work_to_date >= $date) { $className = 'fc-event-yellow'; }
                else if($work->work_status == 'Problem' && $work->work_from_date <= $date && $work->work_to_date >= $date) { $className = 'fc-event-red'; }
                else if($work->work_status != 'Complete' && $work->work_to_date < $date) { $className = 'fc-event-red'; }
                else {$className = 'fc-event-skin'; }
                
                $final = array();
                $final['id'] = $work->id;
                $final['title'] = $work->work_title;
                $final['start'] = $work->work_from_date;
                $final['end'] = $work->work_to_date;
                $final['allDay'] = true;
                $final['url'] = $url;
                $final['className'] = $className;
                array_push($events, $final);
            } */

            //Zend_Debug::dump($events);
            echo json_encode($events);
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        } 
        
    }


}

